//$Id: form-win.h,v 1.5 2001/03/23 15:14:46 cactus Exp $ -*- c++ -*-

/* Guikachu Copyright (C) 2001 RDI Gerg <cactus@cactus.rulez.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef GUIKATCHU_FORM_WIN_H
#define GUIKATCHU_FORM_WIN_H

namespace Guikachu
{
    namespace GUI
    {
	class FormWindow;
    }
}

#include "form-res.h"
#include "form-editor/form.h"
#include "form-editor/widget.h"

#include <gtk--/window.h>
#include <gtk--/tree.h>
#include <gtk--/tooltips.h>
#include <gnome--/canvas.h>

#include <glade/glade-xml.h>

namespace Guikachu
{
    namespace GUI
    {
	class FormWindow: public SigC::Object
	{
	    Resources::Form     *res;
	    
	    GladeXML            *gui;
	    Gtk::Window         *window;
	    Gtk::Window         *property_window;
	    
	    Gnome::Canvas       *canvas;
	    Gtk::TreeItem       *top_treeitem;
	    FormEditor::Form    *form;

	    Gtk::Tooltips        tips;
	    
	public:
	    FormWindow (Resources::Form *res);
	    ~FormWindow ();
	    void show ();

	    void show_property_editor (Gtk::Widget *widget);
	    Gnome::Canvas *get_canvas () const { return canvas; };
	private:
	    void create_palette ();
	    
	    int delete_event_impl (GdkEventAny *e);
	    int property_delete_event_impl (GdkEventAny *e);
	    void update ();

	    void add_widget_cb (Resources::Widgets::Type type);

	    void toplevel_activate_cb ();
	    void widget_activate_cb (Resources::Widgets::Widget *widget);
	};
    };
};

#endif /* !GUIKATCHU_DIALOG_WIN_H */
